<template>
  <div class="query-panel-selector d-flex flex-grow-0 flex-row bg-light">
    <div class="btn-group">
      <button class="btn btn-light"
        v-bind:class="isActive('table-display-panel')"
        @click="select('table-display-panel')">
        Tabela
      </button>
      <button class="btn btn-light"
        v-bind:class="isActive('main-plot-panel')"
        @click="select('main-plot-panel')">
        Gráficos
      </button>
      <template v-if="query.query.isStation">
        <button class="btn btn-light"
                v-bind:class="isActive('station-plot-panel')"
                @click="select('station-plot-panel')">
          Dados da estação
        </button>
      </template>
      <button class="btn btn-light"
        v-bind:class="isActive('skewt-plot-panel')"
        @click="select('skewt-plot-panel')">
        Tefigrama
      </button>
      <router-link class="btn btn-light" :to="details" target='_blank'>
        Detalhe
      </router-link>
    </div>
    <div class="btn-group ml-auto">
      <button class="btn" @click="closeQueryPanel()">
        <font-awesome-icon icon="times"/>
      </button>
    </div>
  </div>
</template>

<script>
import { SET_WORKSPACE_QUERY_CURRENT_PANEL, SET_WORKSPACE_QUERY, REMOVE_WORKSPACE_CUSTOM_LOCAL } from '@/workspace/store/mutations'
import WorkspaceGetter from '@/workspace/mixins/WorkspaceGetter'

export default {
  name: 'querypanel',

  mixins: [
    WorkspaceGetter,
  ],

  computed: {
    query: {
      get() {
        return this.$store.getters.workspaceQuery(this.workspaceId)
      }
    },

    currentQueryPanel: {
      get() {
        return this.query.ui.currentPanel
      }
    },

    referenceTime: {
      get() {
        return this.$store.getters.workspaceReferenceTime(this.workspaceId)
      }
    },

    details: {
      get() {
        return this.query.query.isStation
          ? `/detail/${this.referenceTime}/${this.query.query.latitude}/${this.query.query.longitude}/${this.query.query.stationId}`
          : `/detail/${this.referenceTime}/${this.query.query.latitude}/${this.query.query.longitude}`
      }
    },
  },

  watch: {
    query(after) {
      if(!after) {
        this.closeQueryPanel()
      }
    }
  },

  methods: {
    isActive(panelName) {
      return {
        'active': panelName === this.currentQueryPanel
      }
    },

    select(panelName) {
      this.$store.commit(SET_WORKSPACE_QUERY_CURRENT_PANEL, {
        workspaceId: this.workspaceId,
        panel: panelName
      })
    },

    closeQueryPanel() {
      this.$store.commit(REMOVE_WORKSPACE_CUSTOM_LOCAL, {
        workspaceId: this.workspaceId
      })
      this.$store.commit(SET_WORKSPACE_QUERY, {
        workspaceId: this.workspaceId,
        query: {
          ...this.query.query
        }
      })
    },
  },
}
</script>
